from enum import Enum

class Direction (Enum):
    NORTH = 0
    SOUTH = 1
    EAST = 2
    WEST = 3

class Input(Enum):
    LEFT = 0
    RIGHT = 1
    FORWARD = 2
    BACKWARD = 3


class Action(Enum):
    GoNorth = 10
    GoSouth = 11
    GoEast = 12
    GoWest = 13
    NoAction = 20


class StateItem:
    def __init__(self, action, state):
        self.action = action
        self.state = state


class StateMachine:
    def __init__(self):
        self.stateActionDiagram = [
            # north
            [StateItem( Action.GoWest,Direction.WEST),
             StateItem(Action.GoEast, Direction.EAST),
             StateItem(Action.GoNorth, Direction.NORTH),
             StateItem(Action.GoSouth, Direction.SOUTH)],

            # South
            [StateItem(Action.GoEast, Direction.EAST),
             StateItem(Action.GoWest, Direction.WEST),
             StateItem(Action.GoSouth, Direction.SOUTH),
             StateItem(Action.GoNorth, Direction.NORTH)],

            # east
            [StateItem(Action.GoNorth, Direction.NORTH),
             StateItem(Action.GoSouth, Direction.SOUTH),
             StateItem(Action.GoEast, Direction.EAST),
             StateItem(Action.GoWest, Direction.WEST)],

            # west
            [StateItem(Action.GoSouth, Direction.SOUTH),
             StateItem(Action.GoNorth, Direction.NORTH),
             StateItem(Action.GoWest, Direction.WEST),
             StateItem(Action.GoEast, Direction.EAST)],
        ]

        self.currentState = Direction.NORTH
        self.action = Action.NoAction

    def nextInput(self, input):
        ix = self.currentState.value
        state = self.stateActionDiagram[ix][input.value]

        self.currentState = state.state
        self.action = state.action
        return self.action